<template>
  <section class="news-section" id="news">
    <div class="wrapper">
      <BaseTitle class="news-section__heading" :isLight="true">
        Latest News
      </BaseTitle>
      <div class="news-slider">
        <CircleButton
          @click.native="moveToPrevCard"
          class="news-slider__button news-slider__prev-button"
        >
          <i class="fa-solid fa-chevron-left news-slider__icon"></i>
        </CircleButton>

        <Flicking
          :options="flickingOptions"
          class="news-slider__flicking"
          :plugins="flickingPlugins"
          ref="flicking"
        >
          <NewsCard
            v-for="(card, i) in cards"
            v-bind="card"
            :key="i"
            class="news-slider__item"
          />
          <div
            slot="viewport"
            class="flicking-pagination news-slider__pagination"
          ></div>
        </Flicking>
        <CircleButton
          @click.native="moveToNextCard"
          class="news-slider__button news-slider__next-button"
        >
          <i class="fa-solid fa-chevron-right news-slider__icon"></i>
        </CircleButton>
      </div>
    </div>
  </section>
</template>

<script lang="ts">
import { Component, Vue } from "vue-property-decorator";
import type { FlickingOptions } from "@egjs/flicking";
import { Pagination } from "@egjs/flicking-plugins";
import "@egjs/flicking-plugins/dist/pagination.css";
import { AutoPlay } from "@egjs/flicking-plugins";
import BaseTitle from "@/components/BaseTitle.vue";
import CircleButton from "@/components/CircleButton.vue";
import NewsCard from "@/components/NewsCard.vue";
import type { Flicking } from "@egjs/vue-flicking";

type NewsCardItem = {
  imageUrl: string;
  title: string;
  text: string;
  authorProfileUrl: string;
  authorName: string;
  date: Date;
};

@Component({ components: { BaseTitle, CircleButton, NewsCard } })
export default class HeaderSlider extends Vue {
  flickingOptions: Partial<FlickingOptions> = {
    horizontal: true,
    panelsPerView: 3,
    align: "prev",
    circular: true,
    autoResize: true,
    duration: 1000,
  };

  flickingPlugins = [
    new Pagination({ type: "bullet" }),
    // new AutoPlay({ duration: 5000, direction: "NEXT", stopOnHover: false }),
  ];

  $refs: Vue["$refs"] & {
    flicking: Flicking;
  };

  moveToPrevCard() {
    const flickingRef = this.$refs.flicking;
    flickingRef.prev();
  }

  moveToNextCard() {
    const flickingRef = this.$refs.flicking;
    flickingRef.next();
  }

  cards: NewsCardItem[] = [
    {
      imageUrl: "/src/assets/news_first_lauren-mancke.png",
      title:
        "See the unmatched beauty of the great. See the unmatched beauty of the great.",
      text: "Free directories: directories are perfect for customers that are searching for Free directories: directories are perfect for customers that are searching for",
      authorProfileUrl: "/src/assets/profile_first_alja_brun.png",
      authorName: "Alja Brun",
      date: new Date("20 Jan 2020"),
    },
    {
      imageUrl: "/src/assets/news_second_matthew-hamilton.png",
      title: "Effective advertising pointers.",
      text: "Having a home based business is a wonderful asset to your life Qualitatificationize a home based business is a wonderful asset to your life",
      authorProfileUrl: "/src/assets/profile_second_dominic_freeman.png",
      authorName: "Dominic Freeman",
      date: new Date("13 Dec 2019"),
    },
    {
      imageUrl: "/src/assets/news_third_joel-filipe.png",
      title: "Hypnotize yourself into the ghost.",
      text: "There are many things that are important to catalog design Flugegenhaimen are many things that are important to catalog design",
      authorProfileUrl: "/src/assets/profile_third_alice_ward.png",
      authorName: "Alice Ward",
      date: new Date("30 Nov 2019"),
    },
    {
      imageUrl: "/src/assets/news_third_joel-filipe.png",
      title: "Hypnotize yourself into the ghost.",
      text: "There are many things that are important to catalog design Flugegenhaimen are many things that are important to catalog design",
      authorProfileUrl: "/src/assets/profile_third_alice_ward.png",
      authorName: "Alice Ward",
      date: new Date("30 Nov 2019"),
    },
    {
      imageUrl: "/src/assets/news_third_joel-filipe.png",
      title: "Hypnotize yourself into the ghost.",
      text: "There are many things that are important to catalog design Flugegenhaimen are many things that are important to catalog design",
      authorProfileUrl: "/src/assets/profile_third_alice_ward.png",
      authorName: "Alice Ward",
      date: new Date("30 Nov 2019"),
    },
  ];
}
</script>

<style lang="scss">
.news-section {
  position: relative;
  padding: 120px 0 170px;
  background-image: url("src/assets/news_slider_background.png"),
    linear-gradient(237.1deg, #24ccfa 11.16%, #3c7fd4 89.18%);
  background-attachment: fixed;
  background-repeat: no-repeat;
  background-position: bottom left;
  overflow: hidden;

  &__heading {
    position: relative;
    margin-bottom: 90px;
  }
}

.news-slider {
  position: relative;
  display: flex;
  justify-content: center;
  align-items: center;
  margin-right: -30px;
  max-width: 100%;

  &__button {
    position: absolute;
    cursor: pointer;
  }

  @media screen and (max-width: 1390px) {
    &__button {
      display: none !important;
    }
  }

  &__prev-button {
    left: -100px;
  }

  &__next-button {
    right: -100px;
  }

  &__flicking {
    position: static !important;
    margin: 0;
    display: flex;
    flex-direction: column;
    gap: 40px;
    justify-content: center;
    align-items: center;
  }

  &__item {
    margin-right: 30px;
  }

  &__pagination {
    position: absolute;
    line-height: normal;
    display: flex;
    gap: 40px;
    justify-content: center;
    align-items: center;
    bottom: -50px;
  }

  &__icon {
    font-size: 10px;
    line-height: 1.6;
    color: $white;
  }
}
</style>
